# ZombieMod Admin System
# By Owned|Myself
# V 1.0, Public

import es, playerlib, popuplib, cfglib

#Addon Info
info = es.AddonInfo()
info.name			= "ZombieMod Admin System"
info.version		= "1.0"
info.author			= "Owned|Myself"
info.basename		= "zmodadmin"
info.description	= "A small admin system for the new ZombieMod Public Beta (2.0.1D)"

#Admin List (Durr)
admin_list = ['STEAM_ID_LAN']

#CFG Info and Variables. DO NOT EDIT HERE. EDIT CFG FILE.
zmascfg = cfglib.AddonCFG(es.getAddonPath("zmodadmin") + "/zmas.cfg")
zmascfg.text('============================================================')
zmascfg.text('===========ZombieMod Admin System Configuration=============')
zmascfg.text('============================================================')
zmascfg.text('')
zmascfg.text('Phrase Settings:')
respawnphrase		=	zmascfg.cvar('respawnphrase',	'!zspawn',	'The Phrase to force a player to say when they are made to respawn')
telephrase			=	zmascfg.cvar('telephrase',		'!ztele',	'The phrase to force a player to say when they are made to teleport')
stuckphrase			=	zmascfg.cvar('stuckphrase',		'!zstuck',	'The phrase to force a player to say when they are made to "unstuck"')
zmascfg.text('')
zmascfg.text('Menu Settings:')
zscomenable			=	zmascfg.cvar('zscomenable',		1,	'If set to 1, Enables Server Commands Option. Otherwise, it does not function')
zmascfg.write()

#Popup Creation, CFG execution, Command Registry and Addon Info Publication
def load():
    es.regsaycmd('!zadmin', 'zmodadmin/zmmenu', 'ZombieMod Admin Menu')
    zmenu = popuplib.create('zmenu')
    zmenu.addline('Select a category:')
    zmenu.addline('--------------------')
    zmenu.addline('->1. Punishments')
    zmenu.addline('->2. Player Commands')
    zmenu.addline('->3. Server Commands')
    zmenu.addline('--------------------')
    zmenu.addline('0. Exit')
    zmenu.menuselect = zmenusel
    
    zpmenu = popuplib.create('zpmenu')
    zpmenu.addline('Select a Punishment:')
    zpmenu.addline('--------------------')
    zpmenu.addline('->1. Slay')
    zpmenu.addline('->2. Disarm')
    zpmenu.addline('->3. Zombify')
    zpmenu.addline('--------------------')
    zpmenu.addline('0. Exit')
    zpmenu.menuselect = zpmenusel
    
    zpcmenu = popuplib.create('zpcmenu')
    zpcmenu.addline('Select a Command:')
    zpcmenu.addline('--------------------')
    zpcmenu.addline('->1. Force Spawn')
    zpcmenu.addline('->2. Force Teleport')
    zpcmenu.addline('->3. Force Unstuck')
    zpcmenu.addline('--------------------')
    zpcmenu.addline('0. Exit')
    zpcmenu.menuselect = zpcmenusel
    
    zsmenu = popuplib.create('zsmenu')
    zsmenu.addline('Select a Server Command:')
    zsmenu.addline('--------------------')
    zsmenu.addline('->1. Enable Respawn')
    zsmenu.addline('->2. Disable Respawn')
    zsmenu.addline('->3. Voice Off')
    zsmenu.addline('->4. Voice On')
    zsmenu.addline('->5. Enable Zombie Talk')
    zsmenu.addline('->6. Disable Zombie Talk')
    zsmenu.addline('--------------------')
    zsmenu.addline('0. Exit')
    zsmenu.menuselect = zsmenusel
    
    zmascfg.execute()
    
    es.set("zmas_version",info.version)
    es.makepublic("zmas_version")

def unload():
    es.unregsaycmd('!zadmin')
    popuplib.delete('zmenu')
    popuplib.delete('zpmenu')
    popuplib.delete('zpcmenu')
    popuplib.delete('zsmenu')
    popuplib.delete('slay_player_list')
    popuplib.delete('disarm_player_list')
    popuplib.delete('zombify_player_list')
    popuplib.delete('ztele_player_list')
    popuplib.delete('zstuck_player_list')
    print 'ZombieMod Admin System has been unloaded. Thanks for trying it out!'

#Admin Check
def zmmenu():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if steam in admin_list:
        popuplib.send('zmenu', userid)

#Main Menu Select
def zmenusel(caller, choice, popupid):
    if choice == 1:
        popuplib.send('zpmenu', caller)
    if choice == 2:
        popuplib.send('zpcmenu', caller)
    if choice == 3:
        if zscomenable == 1:
            popuplib.send('zsmenu', caller)
        else:
            es.tell(caller, 'This Function is Disabled!')
            popuplib.send('zmenu', caller)

#Punishment menu select
def zpmenusel(caller, choice, popupid):
    if choice == 1:
        zslaymenu = popuplib.easymenu('slay_player_list', '_popup_choice', slayplayer)
        zslaymenu.settitle('Select a Player to Slay:')
        zslaylist = playerlib.getPlayerList('#alive')
        for players in zslaylist:
            pl_userid = int(players)
            pl_name = players.get('name')
            zslaymenu.addoption(pl_userid, pl_name)
        zslaymenu.send(caller)
    elif choice == 2:
        disarmmenu = popuplib.easymenu('disarm_player_list', '_popup_choice', playerSelected)
        disarmmenu.settitle('Select a Player to Disarm')
        disarmlist = playerlib.getPlayerList('#ct')
        for players in disarmlist:
            ct_userid = int(players)
            ct_name = players.get('name')
            disarmmenu.addoption(ct_userid, ct_name)
        disarmmenu.send(caller)
    elif choice == 3:
        zombifymenu = popuplib.easymenu('zombify_player_list', '_popup_choice', zombifyplayer)
        zombifymenu.settitle('Select a Player to Zombify')
        zombifylist = playerlib.getPlayerList('#alive')
        for players in zombifylist:
            ct_userid = int(players)
            ct_name = players.get('name')
            zombifymenu.addoption(ct_userid, ct_name)
        zombifymenu.send(caller)
    else: popuplib.send('zmenu', caller)

#Player Command Menu Select
def zpcmenusel(caller, choice, popupid):
    if choice == 1:
        spawnlist = playerlib.getPlayerList('#dead')
        for players in spawnlist:
            es.sexec(players, 'say %s'%(respawnphrase))
            es.tell(players, '#multi', 'You have been forced to %srespawn!'%('#green'))
        popuplib.send('zmenu', caller)
    elif choice == 2:
        ztelemenu = popuplib.easymenu('ztele_player_list', '_popup_choice', teleplayer)
        ztelemenu.settitle('Select a Player to teleport:')
        ztelelist = playerlib.getPlayerList('#alive')
        for players in ztelelist:
            pl_userid = int(players)
            pl_name = players.get('name')
            ztelemenu.addoption(pl_userid, pl_name)
        ztelemenu.send(caller)
    elif choice == 3:
        zstuckmenu = popuplib.easymenu('zstuck_player_list', '_popup_choice', stuckplayer)
        zstuckmenu.settitle('Select a Player to unstuck:')
        zstucklist = playerlib.getPlayerList('#alive')
        for players in zstucklist:
            pl_userid = int(players)
            pl_name = players.get('name')
            zstuckmenu.addoption(pl_userid, pl_name)
        zstuckmenu.send(caller)
    else: popuplib.send('zmenu', caller)

#Server Command Menuselect
def zsmenusel(caller, choice, popupid):
    if choice == 1:
        es.server.queuecmd('zombie_respawn_as_zombie 1')
        es.tell(caller, 'Zombie Respawn enabled!')
        popuplib.send('zmenu', caller)
    elif choice == 2:
        es.server.queuecmd('zombie_respawn_as_zombie 0')
        es.tell(caller, 'Zombie Respawn disabled!')
        popuplib.send('zmenu', caller)
    elif choice == 3:
        es.server.queuecmd('sv_voiceenable 0')
        es.tell(caller, 'Voice Chat disabled!')
        popuplib.send('zmenu', caller)
    elif choice == 4:
        es.server.queuecmd('sv_voiceenable 1')
        es.tell(caller, 'Voice chat enabled!')
        popuplib.send('zmenu', caller)
    elif choice == 5:
        es.server.queuecmd('zombie_talk 1')
        es.tell(caller, 'Zombie Talk enabled!')
        popuplib.send('zmenu', caller)
    elif choice == 6:
        es.server.queuecmd('zombie_talk 0')
        es.tell(caller, 'Zombie Talk disabled!')
        popuplib.send('zmenu', caller)
    else: popuplib.send('zmenu', caller)

#Disarm Menuselect
def playerSelected(caller, target, menuname): 
    disarmplayer = playerlib.getPlayer(target)
    disarmplayer.setPrimaryAmmo('0')
    disarmplayer.setPrimaryClip('0') 
    es.tell(caller, 'The name of the player you disarmed is %s'%(disarmplayer.get('name')))
    es.tell(target, 'You have been#green disarmed!')
    popuplib.send('zmenu', caller)

#Slay Player Menuselect
def slayplayer(caller, target, menuname):
    name = es.getplayername(target)
    es.server.queuecmd('zombie_slay "%s"'%(name))
    es.tell(target, '#multi', 'You have been#green slayed!')
    popuplib.send('zmenu', caller)

#Teleport Player Menuselect
def teleplayer(caller, target, menuname):
    es.sexec(target, 'say %s'%(telephrase))
    es.tell(target, '#multi', 'You have been forced to#green teleport!')
    popuplib.send('zmenu', caller)

#Stuck Player Menuselect
def stuckplayer(caller, target, menuname):
    es.sexec(target, 'say %s'%(stuckphrase))
    es.tell(target, '#multi', 'You have been forced to#green %s!'%(stuckphrase))
    popuplib.send('zmenu', caller)

#Zombify Player Menuselect
def zombifyplayer(caller, target, menuname):
    zombieplayer = playerlib.getPlayer(target)
    zombieplayername = zombieplayer.get('name')
    es.server.queuecmd('zombie_player "%s"'%(zombieplayername))
    popuplib.send('zmenu', caller)